/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	"context"
	"time"

	v1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_openstack/openstack/v1beta1"
	scheme "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-openstack/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// OpenStackMachineTemplatesGetter has a method to return a OpenStackMachineTemplateInterface.
// A group's client should implement this interface.
type OpenStackMachineTemplatesGetter interface {
	OpenStackMachineTemplates(namespace string) OpenStackMachineTemplateInterface
}

// OpenStackMachineTemplateInterface has methods to work with OpenStackMachineTemplate resources.
type OpenStackMachineTemplateInterface interface {
	Create(ctx context.Context, openStackMachineTemplate *v1beta1.OpenStackMachineTemplate, opts v1.CreateOptions) (*v1beta1.OpenStackMachineTemplate, error)
	Update(ctx context.Context, openStackMachineTemplate *v1beta1.OpenStackMachineTemplate, opts v1.UpdateOptions) (*v1beta1.OpenStackMachineTemplate, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1beta1.OpenStackMachineTemplate, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1beta1.OpenStackMachineTemplateList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.OpenStackMachineTemplate, err error)
	OpenStackMachineTemplateExpansion
}

// openStackMachineTemplates implements OpenStackMachineTemplateInterface
type openStackMachineTemplates struct {
	client rest.Interface
	ns     string
}

// newOpenStackMachineTemplates returns a OpenStackMachineTemplates
func newOpenStackMachineTemplates(c *InfrastructureV1beta1Client, namespace string) *openStackMachineTemplates {
	return &openStackMachineTemplates{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the openStackMachineTemplate, and returns the corresponding openStackMachineTemplate object, and an error if there is any.
func (c *openStackMachineTemplates) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.OpenStackMachineTemplate, err error) {
	result = &v1beta1.OpenStackMachineTemplate{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("openstackmachinetemplates").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of OpenStackMachineTemplates that match those selectors.
func (c *openStackMachineTemplates) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.OpenStackMachineTemplateList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1beta1.OpenStackMachineTemplateList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("openstackmachinetemplates").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested openStackMachineTemplates.
func (c *openStackMachineTemplates) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("openstackmachinetemplates").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a openStackMachineTemplate and creates it.  Returns the server's representation of the openStackMachineTemplate, and an error, if there is any.
func (c *openStackMachineTemplates) Create(ctx context.Context, openStackMachineTemplate *v1beta1.OpenStackMachineTemplate, opts v1.CreateOptions) (result *v1beta1.OpenStackMachineTemplate, err error) {
	result = &v1beta1.OpenStackMachineTemplate{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("openstackmachinetemplates").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(openStackMachineTemplate).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a openStackMachineTemplate and updates it. Returns the server's representation of the openStackMachineTemplate, and an error, if there is any.
func (c *openStackMachineTemplates) Update(ctx context.Context, openStackMachineTemplate *v1beta1.OpenStackMachineTemplate, opts v1.UpdateOptions) (result *v1beta1.OpenStackMachineTemplate, err error) {
	result = &v1beta1.OpenStackMachineTemplate{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("openstackmachinetemplates").
		Name(openStackMachineTemplate.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(openStackMachineTemplate).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the openStackMachineTemplate and deletes it. Returns an error if one occurs.
func (c *openStackMachineTemplates) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("openstackmachinetemplates").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *openStackMachineTemplates) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("openstackmachinetemplates").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched openStackMachineTemplate.
func (c *openStackMachineTemplates) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.OpenStackMachineTemplate, err error) {
	result = &v1beta1.OpenStackMachineTemplate{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("openstackmachinetemplates").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
